/* ----------------------------------------------------------------------------
 *  "THE BEER-WARE LICENSE" (Revision 42):
 *  <mduft@gentoo.org> wrote this file.  As long as you retain this notice you
 *  can do whatever you want with this stuff. If we meet some day, and you think
 *  this stuff is worth it, you can buy me a beer in return.   Markus Duft
 *  ---------------------------------------------------------------------------- */

#ifndef __ACTCACHE_H__
#define __ACTCACHE_H__

#include <sys/select.h>

// Helper macro for easier "foreach set fd in set". current fd is in "i"!
// ATTENTION: Watch your semicolons!
#define ITX_FOREACH_SET_FD(set, nfds, x) \
	if(set != NULL) { int i; for (i = 0; i < nfds; ++i) { if(FD_ISSET(i, set)) { x } } }

typedef enum {
	ActCache_Read,
	ActCache_Write
} cachetype_t;

extern void ActCacheSet(cachetype_t type, int fd);
extern void ActCacheClear(cachetype_t type, int fd);
extern int ActCacheIsSet(cachetype_t type, int fd);

#endif

