/* ----------------------------------------------------------------------------
 *  "THE BEER-WARE LICENSE" (Revision 42):
 *  <mduft@gentoo.org> wrote this file.  As long as you retain this notice you
 *  can do whatever you want with this stuff. If we meet some day, and you think
 *  this stuff is worth it, you can buy me a beer in return.   Markus Duft
 *  ---------------------------------------------------------------------------- */

#include "suacomp.h"
#include "actcache.h"
#include "sync.h"
#include "futimes.h"

#include <fcntl.h>

ITX_DEF_AND_OVERLOAD(int, creat, (char const* file, mode_t mode)) {
	ITX_REAL_FUNC(creat);

	DT("enter: file: %s, mode: 0%o\n", file, mode);

	{
		int fd = real_creat(file, mode);

        if(fd >= 0) {
            ActCacheClear(ActCache_Read, fd);
            ActCacheClear(ActCache_Write, fd);
            sync_unmark(fd);
            futimes_file(fd, file);
        }

		DT("leave: %d\n", fd);
		return fd;
	}
}

