/* ----------------------------------------------------------------------------
 *  "THE BEER-WARE LICENSE" (Revision 42):
 *  <mduft@gentoo.org> wrote this file.  As long as you retain this notice you
 *  can do whatever you want with this stuff. If we meet some day, and you think
 *  this stuff is worth it, you can buy me a beer in return.   Markus Duft
 *  ---------------------------------------------------------------------------- */

#include "suacomp.h"
#include "actcache.h"
#include "sync.h"
#include "futimes.h"

#include <stdio.h>

ITX_DEF_AND_OVERLOAD(int, fclose, (FILE* fp)) {
	ITX_REAL_FUNC(fclose);
    int fd = fileno(fp);

	DT("enter: fp: %p\n", fp);

	ActCacheClear(ActCache_Read, fd);
	ActCacheClear(ActCache_Write, fd);

    sync_unmark(fd);

	{
		int ret = real_fclose(fp);
        futimes_flush(fd);
        futimes_file(fd, NULL);
		DT("leave: %d\n", ret);
		return ret;
	}
}

