/* ----------------------------------------------------------------------------
 *  "THE BEER-WARE LICENSE" (Revision 42):
 *  <mduft@gentoo.org> wrote this file.  As long as you retain this notice you
 *  can do whatever you want with this stuff. If we meet some day, and you think
 *  this stuff is worth it, you can buy me a beer in return.   Markus Duft
 *  ---------------------------------------------------------------------------- */

#include "suacomp.h"
#include "actcache.h"

#include <errno.h>
#include <unistd.h>
#include <stdio.h>

ITX_DEF_AND_OVERLOAD(wint_t, fgetwc, (FILE* fp)) {
    wint_t ret;
	ITX_REAL_FUNC(fgetwc);

	DT("enter: fp: %p\n", fp);

	if(ActCacheIsSet(ActCache_Read, fileno(fp))) {
		ITX_REPEAT(
			errno = 0;
			ret = real_fgetwc(fp);
			D("real_fgetwc(%p) = %d\n", fp, ret);

			if(ret == 0) {
				D("ret = %d, errno = %d\n", ret, errno);

				if(errno == EAGAIN) {
					clearerr(fp);
					ITX_DELAYED_CONTINUE;
				}
			}

			break;
		)
		
		ActCacheClear(ActCache_Read, fileno(fp));
	} else {
		ret = real_fgetwc(fp);
	}
    DT("leave: %d\n", ret);
    return ret;
}

