/* ----------------------------------------------------------------------------
 *  "THE BEER-WARE LICENSE" (Revision 42):
 *  <mduft@gentoo.org> wrote this file.  As long as you retain this notice you
 *  can do whatever you want with this stuff. If we meet some day, and you think
 *  this stuff is worth it, you can buy me a beer in return.   Markus Duft
 *  ---------------------------------------------------------------------------- */

#include "suacomp.h"

#include <errno.h>
#include <string.h>
#include <stdio.h>

ITX_DEF_AND_OVERLOAD(pid_t, fork, ()) {
	pid_t ret = -1;
	ITX_REAL_FUNC(fork);

	// work around makro parameter expansion problems.
	DT("enter%s\n", "");

	ITX_REPEAT(
		errno = 0;
		ret = real_fork();
		D("real_fork() = %d\n", ret);

		if(ret == -1) {
			D("ret = %d, errno = %d\n", ret, errno);

			if(errno == EAGAIN)
				ITX_DELAYED_CONTINUE;
		}

		break;
	)

    DT("leave: %d\n", ret);
	return ret;
}
