/* ----------------------------------------------------------------------------
 *  "THE BEER-WARE LICENSE" (Revision 42):
 *  <mduft@gentoo.org> wrote this file.  As long as you retain this notice you
 *  can do whatever you want with this stuff. If we meet some day, and you think
 *  this stuff is worth it, you can buy me a beer in return.   Markus Duft
 *  ---------------------------------------------------------------------------- */

#include "suacomp.h"
#include "actcache.h"

#include <errno.h>
#include <stdio.h>

ITX_DEF_AND_OVERLOAD(size_t, fread, (void* buf, size_t sz, size_t cnt, FILE* fp)) {
    size_t ret;
	ITX_REAL_FUNC(fread);

	DT("enter: buf: %p, sz: %d, cnt: %d, fp: %p\n", buf, sz, cnt, fp);

	if(ActCacheIsSet(ActCache_Read, fileno(fp))) {
		ITX_REPEAT(
			errno = 0;
			ret = real_fread(buf, sz, cnt, fp);
			D("real_fread(%p, %d, %d, %p) = %d\n", buf, sz, cnt, fp, ret);

			if(ret == 0) {
				D("ret = %d, errno = %d\n", ret, errno);

				if(errno == EAGAIN) {
					clearerr(fp);
					ITX_DELAYED_CONTINUE;
				}
			}

			break;
		)

		ActCacheClear(ActCache_Read, fileno(fp));
	} else {
		ret = real_fread(buf, sz, cnt, fp);
	}
    DT("leave: %d\n", ret);
    return ret;
}
