/* ----------------------------------------------------------------------------
 *  "THE BEER-WARE LICENSE" (Revision 42):
 *  <mduft@gentoo.org> wrote this file.  As long as you retain this notice you
 *  can do whatever you want with this stuff. If we meet some day, and you think
 *  this stuff is worth it, you can buy me a beer in return.   Markus Duft
 *  ---------------------------------------------------------------------------- */

#include "suacomp.h"
#include "actcache.h"
#include "sync.h"
#include "futimes.h"

#include <stdio.h>

ITX_DEF_AND_OVERLOAD(FILE*, freopen, (char const* file, char const* mode, FILE* orig)) {
	ITX_REAL_FUNC(freopen);

	DT("enter: file: %s, mode: %s, old: %p\n", file, mode, orig);

	{
        int oldfd = fileno(orig);
		FILE* fp = real_freopen(file, mode, orig);

        if(oldfd >= 0) {
            ActCacheClear(ActCache_Read, oldfd);
            ActCacheClear(ActCache_Write, oldfd);
            sync_unmark(oldfd);
            futimes_file(oldfd, NULL);
        }

        if(fp) {
            int fd = fileno(fp);
            if(fd >= 0) {
                ActCacheClear(ActCache_Read, fd);
                ActCacheClear(ActCache_Write, fd);
                sync_unmark(fd);
                futimes_file(fd, file);
            }
        }

		DT("leave: %p\n", fp);
		return fp;
	}
}

