/* ----------------------------------------------------------------------------
 *  "THE BEER-WARE LICENSE" (Revision 42):
 *  <mduft@gentoo.org> wrote this file.  As long as you retain this notice you
 *  can do whatever you want with this stuff. If we meet some day, and you think
 *  this stuff is worth it, you can buy me a beer in return.   Markus Duft
 *  ---------------------------------------------------------------------------- */

#include "suacomp.h"
#include "actcache.h"

#include <errno.h>
#include <unistd.h>
#include <stdio.h>

/* we override getchar, even though it only operates on stdin. even there
 * it may be possible for problems to appear (stdin is a tty, right...? :) ) */
ITX_DEF_AND_OVERLOAD(int, getchar, (void)) {
    int ret;
	ITX_REAL_FUNC(getchar);

	// work around makro parameter expansion problems.
	DT("enter%s\n", "");

	if(ActCacheIsSet(ActCache_Read, fileno(stdin))) {
		ITX_REPEAT(
			errno = 0;
			ret = real_getchar();
			D("real_getchar() = %d\n", ret);

			if(ret == 0) {
				D("ret = %d, errno = %d\n", ret, errno);

				if(errno == EAGAIN)
					ITX_DELAYED_CONTINUE;
			}

			break;
		)
		
		ActCacheClear(ActCache_Read, fileno(stdin));
	} else {
		ret = real_getchar();
	}
    DT("leave: %d\n", ret);
    return ret;
}

