/* ----------------------------------------------------------------------------
 *  "THE BEER-WARE LICENSE" (Revision 42):
 *  <mduft@gentoo.org> wrote this file.  As long as you retain this notice you
 *  can do whatever you want with this stuff. If we meet some day, and you think
 *  this stuff is worth it, you can buy me a beer in return.   Markus Duft
 *  ---------------------------------------------------------------------------- */

#include "suacomp.h"

#include <dlfcn.h>
#include <errno.h>
#include <string.h>

#ifndef ITX_STATIC

/* Attention: libc name is hardcoded here, since it is the same since
 * SUA 5.2. However this means you cannot use this library on interix 3.5! */
#ifndef SHARED_LIBC
#error SHARED_LIBC must be defined
#endif

static void* GetLibHandle() {
	static void* hndl = NULL;

	if(!hndl) {
		if(!(hndl = dlopen(SHARED_LIBC, RTLD_LOCAL))) {
			E("failed to open " SHARED_LIBC ": %d (%s)\n", errno, strerror(errno));
		}

		DD("success: loaded %s -> %p\n", SHARED_LIBC, hndl);
	}

	return hndl;
}

void* GetSysFunction(char const* name) {
	void* func = dlsym(GetLibHandle(), name);

	if(!func)
		E("failed to resolve symbol %s!\n", name);
	
	DD("success: resolved %s -> %p\n", name, func);

	return func;
}

#endif

