/* ----------------------------------------------------------------------------
 *  "THE BEER-WARE LICENSE" (Revision 42):
 *  <mduft@gentoo.org> wrote this file.  As long as you retain this notice you
 *  can do whatever you want with this stuff. If we meet some day, and you think
 *  this stuff is worth it, you can buy me a beer in return.   Markus Duft
 *  ---------------------------------------------------------------------------- */

#include "suacomp.h"

#include <unistd.h>
#include <sys/msg.h>
#include <stdarg.h>

ITX_DEF_AND_OVERLOAD(int, msgctl, (int msqid, int cmd, struct msqid_ds* buf)) {
    int res;
	ITX_REAL_FUNC(msgctl);
	DT("enter: msqid: %d, cmd: %d, buf: %p\n", msqid, cmd, buf);

	switch(cmd) {
	case IPC_STAT:
		{
			res = real_msgctl(msqid, cmd, buf);
			if(res == 0 && buf) {
				ITX_MAP_UID(buf->msg_perm.uid, False);
				ITX_MAP_UID(buf->msg_perm.cuid, False);
				ITX_MAP_GID(buf->msg_perm.gid, False);
				ITX_MAP_GID(buf->msg_perm.cgid, False);
			}
            DT("leave: %d\n", res);
			return res;
		}
	case IPC_SET:
		{
			if(buf) {
				ITX_MAP_UID(buf->msg_perm.uid, True);
				ITX_MAP_UID(buf->msg_perm.cuid, True);
				ITX_MAP_GID(buf->msg_perm.gid, True);
				ITX_MAP_GID(buf->msg_perm.cgid, True);
			}
			res = real_msgctl(msqid, cmd, buf);
            DT("leave: %d\n", res);
			return res;
		}
	default:
		res = real_msgctl(msqid, cmd, buf);
        DT("leave: %d\n", res);
        return res;
	}
}
