/* ----------------------------------------------------------------------------
 *  "THE BEER-WARE LICENSE" (Revision 42):
 *  <mduft@gentoo.org> wrote this file.  As long as you retain this notice you
 *  can do whatever you want with this stuff. If we meet some day, and you think
 *  this stuff is worth it, you can buy me a beer in return.   Markus Duft
 *  ---------------------------------------------------------------------------- */

#include "suacomp.h"
#include "actcache.h"
#include "sync.h"
#include "futimes.h"

// ... hack, hack :) since we're using cdecl, open is defined without varargs
// to make passing on easier... this should make no difference, as long as
// open does not try to interpret the third argument when O_CREAT is not in
// the flags argument.
#define open __va_open
#include <fcntl.h>
#undef open

ITX_DEF_AND_OVERLOAD(int, open, (char const* file, int flags, mode_t mode)) {
	ITX_REAL_FUNC(open);

	DT("enter: file: %s, flags: 0x%x\n", file, flags);

	{
		int fd = real_open(file, flags, (flags & O_CREAT) ? mode : 0);

        ActCacheClear(ActCache_Read, fd);
        ActCacheClear(ActCache_Write, fd);
        sync_unmark(fd);
        futimes_file(fd, file);

		DT("leave: %d\n", fd);
		return fd;
	}
}

