/* ----------------------------------------------------------------------------
 *  "THE BEER-WARE LICENSE" (Revision 42):
 *  <mduft@gentoo.org> wrote this file.  As long as you retain this notice you
 *  can do whatever you want with this stuff. If we meet some day, and you think
 *  this stuff is worth it, you can buy me a beer in return.   Markus Duft
 *  ---------------------------------------------------------------------------- */

#include "suacomp.h"
#include "actcache.h"
#include "sync.h"

#include <errno.h>
#include <stdio.h>

/* same as getchar/getwchar: we do the EAGAIN wrapping here too, even though
 * this only operates on stdout (mya be a tty too, right...?). */
ITX_DEF_AND_OVERLOAD(int, puts, (const char* buf)) {
    size_t ret;
	ITX_REAL_FUNC(puts);

	DT("enter: buf: %p\n", buf);

    sync_mark(fileno(stdout));

	if(ActCacheIsSet(ActCache_Write, fileno(stdout))) {
		ITX_REPEAT(
			errno = 0;
			ret = real_puts(buf);
			D("real_puts(%p) = %d\n", buf, ret);

			if(ret == 0) {
				D("ret = %d, errno = %d\n", ret, errno);

				if(errno == EAGAIN)
					ITX_DELAYED_CONTINUE;
			}

			break;
		)

		ActCacheClear(ActCache_Write, fileno(stdout));
	} else {
		ret = real_puts(buf);
	}
    DT("leave: %d\n", ret);
    return ret;
}
