/* ----------------------------------------------------------------------------
 *  "THE BEER-WARE LICENSE" (Revision 42):
 *  <mduft@gentoo.org> wrote this file.  As long as you retain this notice you
 *  can do whatever you want with this stuff. If we meet some day, and you think
 *  this stuff is worth it, you can buy me a beer in return.   Markus Duft
 *  ---------------------------------------------------------------------------- */

#include "suacomp.h"

#include <unistd.h>
#include <sys/shm.h>
#include <stdarg.h>

ITX_DEF_AND_OVERLOAD(int, shmctl, (int shmid, int cmd, struct shmid_ds* buf)) {
    int res;
	ITX_REAL_FUNC(shmctl);

	DT("enter: shmid: %d, cmd: %d, buf: %p\n", shmid, cmd, buf);

	switch(cmd) {
	case IPC_STAT:
		{
			res = real_shmctl(shmid, cmd, buf);
			if(res == 0 && buf) {
				ITX_MAP_UID(buf->shm_perm.uid, False);
				ITX_MAP_UID(buf->shm_perm.cuid, False);
				ITX_MAP_GID(buf->shm_perm.gid, False);
				ITX_MAP_GID(buf->shm_perm.cgid, False);
			}
		}
        break;
	case IPC_SET:
		{
			if(buf) {
				ITX_MAP_UID(buf->shm_perm.uid, True);
				ITX_MAP_UID(buf->shm_perm.cuid, True);
				ITX_MAP_GID(buf->shm_perm.gid, True);
				ITX_MAP_GID(buf->shm_perm.cgid, True);
			}
			res = real_shmctl(shmid, cmd, buf);
		}
        break;
	default:
		res = real_shmctl(shmid, cmd, buf);
        break;
	}
    DT("leave: %d\n", res);
    return res;
}
