/* ----------------------------------------------------------------------------
 *  "THE BEER-WARE LICENSE" (Revision 42):
 *  <mduft@gentoo.org> wrote this file.  As long as you retain this notice you
 *  can do whatever you want with this stuff. If we meet some day, and you think
 *  this stuff is worth it, you can buy me a beer in return.   Markus Duft
 *  ---------------------------------------------------------------------------- */

#include "suacomp.h"

#include <unistd.h>

/* a reasonable limit for all current interix versions.
 * this will have to be adapted, when a new interix version
 * changes this value. however, ATM, windows itself has a
 * 32K + 32K (env + arguments) limit. */
#define ITX_ARG_MAX     (32768)

ITX_DEF_AND_OVERLOAD(long, sysconf, (int id)) {
	ITX_REAL_FUNC(sysconf);
    long res = -1;

	DT("enter: id: %d\n", id);

    res = real_sysconf(id);

    switch(id) {
    case _SC_ARG_MAX:
        res = ITX_ARG_MAX;
        break;
    }

    DT("leave: result: %d\n", res);
    return res;
}
