/* ----------------------------------------------------------------------------
 *  "THE BEER-WARE LICENSE" (Revision 42):
 *  <mduft@gentoo.org> wrote this file.  As long as you retain this notice you
 *  can do whatever you want with this stuff. If we meet some day, and you think
 *  this stuff is worth it, you can buy me a beer in return.   Markus Duft
 *  ---------------------------------------------------------------------------- */

#ifndef __SUACOMP_TEST_H__
#define __SUACOMP_TEST_H__

#include <time.h>
#include <stdio.h>

#define MSG(fmt, ...) { fprintf(stderr, "%d %20s:%-3d :: " fmt, time(NULL), __FUNCTION__, __LINE__, __VA_ARGS__); }
#define VMSG(fmt, ...) { if(_verbose) { MSG(fmt, __VA_ARGS__); } }
#define VMSG0(msg) VMSG(msg "%s", "")

#define VSTATUS(status, what) { VMSG("[ %-8s ] " what "\n", status); }

typedef void (*test_func_t)(int argc, char** argv);
typedef struct {
	test_func_t func;
	char const* name;
} test_desc_t;

extern int _verbose;

extern long _success_count;
extern long _nxsuccess_count;
extern long _failure_count;
extern long _xfailure_count;
extern test_desc_t _tests[];

#define OK "ok"
#define FAIL "fail"
#define XFAIL "x-fail"
#define NXOK "!x-ok"

#define EXP_SUCCESS(x) \
	if((x)) { VSTATUS(OK, #x); ++_success_count; } else { VSTATUS(FAIL, #x); ++_failure_count; return; }

#define EXP_FAILURE(x) \
	if(!(x)) { VSTATUS(XFAIL, #x); ++_xfailure_count; } else { VSTATUS(NXOK, #x); ++_nxsuccess_count; return; }

#endif
