/* ----------------------------------------------------------------------------
 *  "THE BEER-WARE LICENSE" (Revision 42):
 *  <mduft@gentoo.org> wrote this file.  As long as you retain this notice you
 *  can do whatever you want with this stuff. If we meet some day, and you think
 *  this stuff is worth it, you can buy me a beer in return.   Markus Duft
 *  ---------------------------------------------------------------------------- */

#include "test.h"
#include "../suacomp.h"

#include <unistd.h>
#include <pwd.h>
#include <string.h>

void test_getpwnam(int argc, char** argv) {
	struct passwd* pwd;
	char* admin_name = GetLocalAdminName(False);

	pwd = getpwnam("root");
	EXP_SUCCESS(pwd != NULL);

	if(pwd != NULL) {
		VMSG("getpwnam(\"root\") = { name: %s, uid: %d, gid: %d }\n", pwd->pw_name, pwd->pw_uid, pwd->pw_gid);
		EXP_SUCCESS(pwd->pw_uid == 0 && (strcmp(pwd->pw_name, "root") == 0));
	}

	EXP_SUCCESS(admin_name != NULL);

	if(!admin_name)
		return;

	pwd = getpwnam(admin_name);
	EXP_SUCCESS(pwd != NULL);

	if(pwd != NULL) {
		VMSG("getpwnam(\"%s\") = { name: %s, uid: %d, gid: %d }\n", admin_name, pwd->pw_name, pwd->pw_uid, pwd->pw_gid);
		EXP_SUCCESS(pwd->pw_uid == 0 && (strcmp(pwd->pw_name, "root") == 0));
	}

	{
		char* lg = getlogin();

		pwd = getpwnam(lg);
		EXP_SUCCESS(pwd != NULL);

		if(pwd != NULL) {
			VMSG("getpwnam(\"%s\") = { name: %s, uid: %d, gid: %d }\n", lg, pwd->pw_name, pwd->pw_uid, pwd->pw_gid);
			EXP_SUCCESS(getuid() == pwd->pw_uid);
		}
	}
}
