/* ----------------------------------------------------------------------------
 *  "THE BEER-WARE LICENSE" (Revision 42):
 *  <mduft@gentoo.org> wrote this file.  As long as you retain this notice you
 *  can do whatever you want with this stuff. If we meet some day, and you think
 *  this stuff is worth it, you can buy me a beer in return.   Markus Duft
 *  ---------------------------------------------------------------------------- */

#include "test.h"
#include "../suacomp.h"

#include <unistd.h>
#include <pwd.h>
#include <string.h>

void test_getpwuid(int argc, char** argv) {
	struct passwd* pwd;

	pwd = getpwuid(0);
	EXP_SUCCESS(pwd != NULL);

	VMSG("getpwuid(0) = { name: %s, uid: %d, gid: %d }\n", pwd->pw_name, pwd->pw_uid, pwd->pw_gid);
	EXP_SUCCESS(pwd->pw_uid == 0 && (strcmp(pwd->pw_name, "root") == 0));

	pwd = getpwuid(ITX_ROOT_UID);
	EXP_SUCCESS(pwd != NULL);

	VMSG("getpwuid(%d) = { name: %s, uid: %d, gid: %d }\n", ITX_ROOT_UID, pwd->pw_name, pwd->pw_uid, pwd->pw_gid);
	EXP_SUCCESS(pwd->pw_uid == 0 && (strcmp(pwd->pw_name, "root") == 0));

	if(getuid() == 0) {
		VMSG0("you are root, no further testing available!");
		return;
	}

	pwd = getpwuid(getuid());
	EXP_SUCCESS(pwd != NULL);

	VMSG("getpwuid(%d) = { name: %s, uid: %d, gid: %d }\n", ITX_ROOT_UID, pwd->pw_name, pwd->pw_uid, pwd->pw_gid);
	EXP_SUCCESS(pwd->pw_name != NULL && (strcmp(pwd->pw_name, "root") != 0) && pwd->pw_uid != 0);

	// also test using output data as input again, etc.
	pwd = getpwuid(pwd->pw_uid);
	EXP_SUCCESS(pwd != NULL);

	VMSG("getpwuid(%d) = { name: %s, uid: %d, gid: %d }\n", ITX_ROOT_UID, pwd->pw_name, pwd->pw_uid, pwd->pw_gid);
	EXP_SUCCESS(pwd->pw_name != NULL && (strcmp(pwd->pw_name, "root") != 0) && pwd->pw_uid != 0);

	// and again, this time with name.
	pwd = getpwnam(pwd->pw_name);
	EXP_SUCCESS(pwd != NULL);

	VMSG("getpwuid(%d) = { name: %s, uid: %d, gid: %d }\n", ITX_ROOT_UID, pwd->pw_name, pwd->pw_uid, pwd->pw_gid);
	EXP_SUCCESS(pwd->pw_name != NULL && (strcmp(pwd->pw_name, "root") != 0) && pwd->pw_uid != 0);
}
