/* ----------------------------------------------------------------------------
 *  "THE BEER-WARE LICENSE" (Revision 42):
 *  <mduft@gentoo.org> wrote this file.  As long as you retain this notice you
 *  can do whatever you want with this stuff. If we meet some day, and you think
 *  this stuff is worth it, you can buy me a beer in return.   Markus Duft
 *  ---------------------------------------------------------------------------- */

#include "test.h"
#include "../suacomp.h"

#include <grp.h>
#include <pwd.h>
#include <string.h>
#include <errno.h>

ITX_DEF(struct group*, getgrgid_ex, (gid_t gid, unsigned long flags));

static char* GetLocalAdminGroupName(int full) {
	static char* name = NULL;
	static char* full_name = NULL;
	ITX_REAL_FUNC(getgrgid_ex);

	if(!name || !full_name) {
		struct group* tmp;

		if((tmp = real_getgrgid_ex(ITX_ROOT_GID, GR_NOMEMBERS)) == NULL)
			E("cannot get real local administrator group name (gid: %d, errno: %d!\n", ITX_ROOT_GID, errno);

		name = strdup(tmp->gr_name);

		if((tmp = real_getgrgid_ex(ITX_ROOT_GID, GR_FULLNAME | GR_NOMEMBERS)) == NULL)
			E("cannot get real local administrator group name (gid: %d, errno: %d!\n", ITX_ROOT_GID, errno);

		full_name = strdup(tmp->gr_name);
	}

	return full ? full_name : name;
}

void test_group_from_gid(int argc, char** argv) {
	char* group = group_from_gid(0, 0);
	VMSG("group_from_gid(0,0) = %s\n", group);
	EXP_SUCCESS(group != NULL && (strcmp(group, GetLocalAdminGroupName(True)) == 0 || strcmp(group, GetLocalAdminGroupName(False)) == 0));

	group = group_from_gid(ITX_ROOT_GID, 0);
	VMSG("group_from_gid(%d,0) = %s\n", ITX_ROOT_GID, group);
	EXP_SUCCESS(group != NULL && (strcmp(group, GetLocalAdminGroupName(True)) == 0 || strcmp(group, GetLocalAdminGroupName(False)) == 0));
}
