/* ----------------------------------------------------------------------------
 *  "THE BEER-WARE LICENSE" (Revision 42):
 *  <mduft@gentoo.org> wrote this file.  As long as you retain this notice you
 *  can do whatever you want with this stuff. If we meet some day, and you think
 *  this stuff is worth it, you can buy me a beer in return.   Markus Duft
 *  ---------------------------------------------------------------------------- */

#include "test.h"

#include <unistd.h>
#include <string.h>

int _verbose = 0;

long _success_count = 0;
long _nxsuccess_count = 0;
long _failure_count = 0;
long _xfailure_count = 0;

int main(int argc, char ** argv) {
	int i;

	for(i = 1; i < argc; ++i) {
		if(strcmp(argv[i], "-v") == 0) _verbose = 1;
	}

	test_desc_t* cur_test = _tests;
	while(cur_test && cur_test->func) {
		MSG("testing %s\n", cur_test->name);
		(cur_test->func)(argc, argv);

		++cur_test;
	}

	MSG("%ld x-ok, %ld !x-ok, %ld x-fail, %ld !x-fail\n", _success_count, _nxsuccess_count, _xfailure_count, _failure_count);

	return _nxsuccess_count + _failure_count;
}
