/* ----------------------------------------------------------------------------
 *  "THE BEER-WARE LICENSE" (Revision 42):
 *  <mduft@gentoo.org> wrote this file.  As long as you retain this notice you
 *  can do whatever you want with this stuff. If we meet some day, and you think
 *  this stuff is worth it, you can buy me a beer in return.   Markus Duft
 *  ---------------------------------------------------------------------------- */

#include "suacomp.h"
#include "include/sys/time.h"
#include <utime.h>

#if (INTERIX_MAJOR < 6)
int utimes(char const * file, struct timeval const tv[2]) {
	if(tv) {
		struct utimbuf ub;
		ub.actime = tv[0].tv_sec;
		ub.modtime = tv[1].tv_sec;

		return utime(file, &ub);
	} else {
		return utime(file, NULL);
	}
}
#else
ITX_DEF_AND_OVERLOAD(int, utimes, (char const * file, struct timeval const tv[2])) {
	ITX_REAL_FUNC(utimes);
	return real_utimes(file, tv);
}
#endif

