/* ----------------------------------------------------------------------------
 *  "THE BEER-WARE LICENSE" (Revision 42):
 *  <mduft@gentoo.org> wrote this file.  As long as you retain this notice you
 *  can do whatever you want with this stuff. If we meet some day, and you think
 *  this stuff is worth it, you can buy me a beer in return.   Markus Duft
 *  ---------------------------------------------------------------------------- */

#include "suacomp.h"
#include "actcache.h"
#include "sync.h"
#include "futimes.h"

// ... hack, hack :) since we're using cdecl, wcs_open is defined without varargs
// to make passing on easier... this should make no difference, as long as our
// wcs_open does not try to interpret the third argument when O_CREAT is not in
// the flags argument.
#define wcs_open __va_wcs_open
#include <fcntl.h>
#undef wcs_open

#include <stdlib.h>

ITX_DEF_AND_OVERLOAD(int, wcs_open, (wchar_t const* file, int flags, mode_t mode)) {
	ITX_REAL_FUNC(wcs_open);

	DT("enter: file: %S, flags: 0x%x\n", file, flags);

	{
		int fd = real_wcs_open(file, flags, (flags & O_CREAT) ? mode : 0);

        ActCacheClear(ActCache_Read, fd);
        ActCacheClear(ActCache_Write, fd);
        sync_unmark(fd);

        {
            int len = wcstombs(NULL, file, 0);
            char* conv = malloc(len + 1);

            if(!conv || wcstombs(conv, file, len + 1) == -1)
                E("cannot convert path to mbs: %S\n", file);

            futimes_file(fd, conv);
            free(conv);
        }

		DT("leave: %d\n", fd);
		return fd;
	}
}

